rem MIRACL - IBM PC/MS-DOS Version 4.0
rem This batch files creates 80386 version of miracl.lib from its component
rem parts using the 32-bit Borland C++ V4.02 (or greater) compiler BCC32
rem
rem Read your compiler documentation for further information
rem 
rem Invoke as "bc32doit". It is assumed that paths have been correctly set up to
rem the compiler, librarian and linker.
rem
rem Provided mainly as a guide for creating a batch file tailored
rem specifically to your own configuration.
rem
rem Note - the module mrmuldv.c is not needed if MR_NOASM is defined
rem Note - one of the modules mrkcm.c mrcomba.c mr87v.c or mr87f.c may be 
rem        required to implement special methods for modular exponentiation
rem
rem
rem Compile MIRACL modules
bcc32  -c -O  mrcore.c
bcc32  -c -O mrarth0.c
bcc32  -c -O -B mrarth1.c
bcc32  -c -O -B mrarth2.c
bcc32  -c -O mralloc.c
bcc32  -c -O mrsmall.c
bcc32  -c -O mrio1.c
bcc32  -c -O mrio2.c
bcc32  -c -O mrgcd.c
bcc32  -c -O mrjack.c
bcc32  -c -O mrxgcd.c
bcc32  -c -O mrarth3.c
bcc32  -c -O mrrand.c
bcc32  -c -O mrprime.c
bcc32  -c -O mrcrt.c
bcc32  -c -O mrscrt.c
bcc32  -c -O -B mrmonty.c
bcc32  -c -O mrpower.c
bcc32  -c -O mrcurve.c
bcc32  -c -O mrfast.c
bcc32  -c -O mrshs.c
bcc32  -c -O mraes.c
bcc32  -c -O mrstrong.c
bcc32  -c -O mrlucas.c
bcc32  -c -O mrbrick.c
bcc32  -c -O mrebrick.c
bcc32  -c -O mrflash.c
bcc32  -c -O mrfrnd.c
bcc32  -c -O mrdouble.c
bcc32  -c -O mrround.c
bcc32  -c -O mrbuild.c
bcc32  -c -O mrflsh1.c
bcc32  -c -O mrpi.c
bcc32  -c -O mrflsh2.c
bcc32  -c -O mrflsh3.c
bcc32  -c -O mrflsh4.c
rem bcc32  -c -B mrkcm.c
rem 
rem Assemble mrmuldv.c ; be careful to use correct version from mrmuldv.any
bcc32  -c -B mrmuldv.c          
rem
rem Create library 'miracl.lib'
del miracl.lib
tlib miracl
tlib miracl +mrflsh4+mrflsh3+mrflsh2+mrpi+mrflsh1
tlib miracl +mrdouble+mrflash+mrfrnd+mrround+mrbuild
tlib miracl +mrio2+mrio1+mrrand+mrprime+mrcrt+mrscrt+mrfast
tlib miracl +mrjack+mrxgcd+mrgcd+mrarth3+mrarth2+mrpower
tlib miracl +mrmonty+mralloc+mrarth1+mrarth0+mrsmall+mrcore+mrmuldv
tlib miracl +mrcurve+mrshs+mraes+mrlucas+mrstrong+mrbrick+mrebrick
del mr*.obj
bcc32  -c -O big
bcc32  -c -O crt
bcc32  -c -O monty
bcc32  -c -O elliptic
bcc32  brent big.obj monty.obj miracl.lib
bcc32  factor.c miracl.lib
bcc32  pk-demo big.obj crt.obj miracl.lib
bcc32  bmark.c miracl.lib
bcc32  -c -O flash
bcc32  sample flash.obj miracl.lib
bcc32  ecsgen  elliptic.obj big.obj miracl.lib
bcc32  ecsign  elliptic.obj big.obj miracl.lib
bcc32  ecsver  elliptic.obj big.obj miracl.lib

