rem MIRACL - IBM PC/MS-DOS Version 4.0
rem This batch files creates miracl.lib from its component parts
rem using the Microsoft 32-bit compiler, (as used in Windows '95
rem and Windows NT), and the Microsoft LIB librarian utility
rem Also included are the commands to create some of the example programs
rem
rem Read your compiler documentation for further information
rem 
rem Invoke as "ms32doit". It is assumed that paths have been correctly set up
rem to the compiler, librarian and linker.
rem
rem Provided mainly as a guide for creating a batch file tailored
rem specifically to your own configuration.
rem
rem Note - the module mrmuldv.c is not needed if MR_NOASM is defined
rem
rem
rem Compile MIRACL modules
cl /c /O2 mrcore.c
cl /c /O2 mrarth0.c
cl /c /O2 mrarth1.c
cl /c /O2 mrarth2.c
cl /c /O2 mralloc.c
cl /c /O2 mrsmall.c
cl /c /O2 mrio1.c
cl /c /O2 mrio2.c
cl /c /O2 mrgcd.c
cl /c /O2 mrjack.c
cl /c /O2 mrxgcd.c
cl /c /O2 mrarth3.c
cl /c /O2 mrrand.c
cl /c /O2 mrprime.c
cl /c /O2 mrcrt.c
cl /c /O2 mrscrt.c
cl /c /O2 mrmonty.c
cl /c /O2 mrpower.c
cl /c /O2 mrcurve.c
cl /c /O2 mrfast.c
cl /c /O2 mrlucas.c
cl /c /O2 mrshs.c
cl /c /O2 mraes.c
cl /c /O2 mrstrong.c
cl /c /O2 mrbrick.c
cl /c /O2 mrebrick.c
cl /c /O2 mrflash.c
cl /c /O2 mrfrnd.c
cl /c /O2 mrdouble.c
cl /c /O2 mrround.c
cl /c /O2 mrbuild.c
cl /c /O2 mrflsh1.c
cl /c /O2 mrpi.c
cl /c /O2 mrflsh2.c
cl /c /O2 mrflsh3.c
cl /c /O2 mrflsh4.c

cl /c /O2 mrmuldv.c

rem
rem Create library 'miracl.lib'
del miracl.lib

lib /OUT:miracl.lib mrflsh4.obj mrflsh3.obj mrflsh2.obj mrpi.obj mrflsh1.obj
lib /OUT:miracl.lib miracl.lib mrdouble.obj mrflash.obj mrfrnd.obj mrround.obj mrbuild.obj
lib /OUT:miracl.lib miracl.lib mrio2.obj mrio1.obj mrrand.obj mrprime.obj mrcrt.obj mrscrt.obj mrfast.obj
lib /OUT:miracl.lib miracl.lib mrjack.obj mrxgcd.obj mrgcd.obj  mrarth3.obj mrarth2.obj mrpower.obj
lib /OUT:miracl.lib miracl.lib mrmonty.obj mralloc.obj mrarth1.obj mrarth0.obj mrsmall.obj mrcore.obj mrmuldv.obj
lib /OUT:miracl.lib miracl.lib mrcurve.obj mrshs.obj mraes.obj mrlucas.obj mrstrong.obj mrbrick.obj mrebrick.obj
del mr*.obj
rem
cl /c /O2 big.cpp
cl /c /O2 monty.cpp
cl /c /O2 crt.cpp
rem Compile and link example programs
cl /c /O2 brute.cpp
link brute.obj big.obj miracl.lib
cl /c /O2 brent.cpp
link brent.obj big.obj monty.obj miracl.lib
cl /c /O2 pk-demo.cpp
link pk-demo.obj big.obj crt.obj miracl.lib
cl /c bmark.c
link bmark.obj miracl.lib
cl /c /O2 flash.cpp


