rem MIRACL - IBM PC/MS-DOS Version 4.0
rem This batch files creates 80386 version of miracl.lib from its component
rem parts using the 32-bit DJGPP C/C++ V2.01 (or greater) compiler GCC
rem
rem Read your compiler documentation for further information
rem 
rem Invoke as "gcdoit". It is assumed that paths have been correctly set up to
rem the compiler, librarian and linker.
rem
rem Provided mainly as a guide for creating a batch file tailored
rem specifically to your own configuration.
rem
rem Note - the module mrmuldv.c is not needed if MR_NOASM is defined
rem Note - the inline assember and the optimizer don't seem to co-exist 
rem         happily
rem 
rem Use with mirdef.h32
rem
rem Compile MIRACL modules
gcc -c -O2 mrcore.c
gcc -c -O2 mrarth0.c
gcc -c  mrarth1.c
gcc -c  mrarth2.c
gcc -c -O2 mralloc.c
gcc -c -O2 mrsmall.c
gcc -c -O2 mrio1.c
gcc -c -O2 mrio2.c
gcc -c -O2 mrgcd.c
gcc -c -O2 mrjack.c
gcc -c -O2 mrxgcd.c
gcc -c -O2 mrarth3.c
gcc -c -O2 mrrand.c
gcc -c -O2 mrprime.c
gcc -c -O2 mrcrt.c
gcc -c -O2 mrscrt.c
gcc -c  mrmonty.c
gcc -c  mrpower.c
gcc -c -O2 mrcurve.c
gcc -c mrfast.c
gcc -c -O2 mrshs.c
gcc -c -O2 mraes.c
gcc -c -O2 mrlucas.c
gcc -c -O2 mrstrong.c
gcc -c -O2 mrbrick.c
gcc -c -O2 mrebrick.c
gcc -c -O2 mrflash.c
gcc -c -O2 mrfrnd.c
gcc -c -O2 mrdouble.c
gcc -c -O2 mrround.c
gcc -c -O2 mrbuild.c
gcc -c -O2 mrflsh1.c
gcc -c -O2 mrpi.c
gcc -c -O2 mrflsh2.c
gcc -c -O2 mrflsh3.c
gcc -c -O2 mrflsh4.c
gcc -c -O2 mrkcm.c
as mrmuldv.s -o mrmuldv.o
ar rc miracl.a mrcore.o mrarth0.o mrarth1.o mrarth2.o mralloc.o mrsmall.o
ar r  miracl.a mrio1.o mrio2.o mrjack.o mrgcd.o mrxgcd.o mrarth3.o
ar r  miracl.a mrrand.o mrprime.o mrcrt.o mrscrt.o mrmonty.o mrcurve.o mrpower.o
ar r  miracl.a mrfast.o mrshs.o mraes.o mrlucas.o mrstrong.o mrbrick.o mrflash.o mrfrnd.o
ar r  miracl.a mrdouble.o mrround.o mrbuild.o mrflsh1.o mrpi.o mrebrick.o
ar r  miracl.a mrflsh2.o mrflsh3.o mrflsh4.o mrkcm.o mrmuldv.o
del mr*.o
gpp  -c big.cpp
gpp  -c crt.cpp
gpp  -c monty.cpp
gpp  -c elliptic.cpp
gpp  brent.cpp big.o monty.o miracl.a -o brent.exe
gpp  -c flash.cpp
gpp  sample.cpp flash.o miracl.a -o sample.exe
gpp  ecsgen.cpp elliptic.o big.o miracl.a -o ecsgen.exe
gpp  ecsign.cpp elliptic.o big.o miracl.a -o ecsign.exe
gpp  ecsver.cpp elliptic.o big.o miracl.a -o ecsver.exe

