/*
 *   MIRACL methods for evaluating lucas V function
 *   mrlucas.c 
 *
 *   Copyright (c) 1988-1999 Shamus Software Ltd.
 */

#include <stdio.h>
#include <miracl.h>

extern miracl *mr_mip;

void nres_lucas(big p,big r,big vp,big v)
{
    int i,nb;
    if (mr_mip->ERNUM) return;

    MR_IN(107)

    if (size(r)==0) 
    {
        zero(vp);
        convert(2,v);
        nres(v,v);
        MR_OUT
        return;
    }
    if (size(r)==1 || size(r)==(-1))
    { /* note - sign of r doesn't matter */
        convert(2,vp);
        nres(vp,vp);
        copy(p,v);
        MR_OUT
        return;
    }

    copy(p,mr_mip->w3);
    
    convert(2,mr_mip->w4);
    nres(mr_mip->w4,mr_mip->w4);     /* w4=2 */

    copy(mr_mip->w4,mr_mip->w8);
    copy(mr_mip->w3,mr_mip->w9);

    copy(r,mr_mip->w1);
    insign(PLUS,mr_mip->w1);         
    decr(mr_mip->w1,1,mr_mip->w1);

    if (mr_mip->base==mr_mip->base2)
    {
        nb=logb2(mr_mip->w1);
        for (i=nb-1;i>=0;i--)
        {
            if (mr_mip->user!=NULL) (*mr_mip->user)();

            if (mr_testbit(mr_mip->w1,i))
            {
                nres_modmult(mr_mip->w8,mr_mip->w9,mr_mip->w8);
                nres_modsub(mr_mip->w8,mr_mip->w3,mr_mip->w8);
                nres_modmult(mr_mip->w9,mr_mip->w9,mr_mip->w9);
                nres_modsub(mr_mip->w9,mr_mip->w4,mr_mip->w9);

            }
            else
            {
                nres_modmult(mr_mip->w9,mr_mip->w8,mr_mip->w9);
                nres_modsub(mr_mip->w9,mr_mip->w3,mr_mip->w9);
                nres_modmult(mr_mip->w8,mr_mip->w8,mr_mip->w8);
                nres_modsub(mr_mip->w8,mr_mip->w4,mr_mip->w8);
            }  
        }
    }
    else
    {
        expint(2,logb2(mr_mip->w1)-1,mr_mip->w2);                                                                                                   

        while (!mr_mip->ERNUM && size(mr_mip->w2)!=0)
        { /* use binary method */
            if (compare(mr_mip->w1,mr_mip->w2)>=0)
            { /* vp=v*vp-p, v=v*v-2 */ 
                nres_modmult(mr_mip->w8,mr_mip->w9,mr_mip->w8);
                nres_modsub(mr_mip->w8,mr_mip->w3,mr_mip->w8);
                nres_modmult(mr_mip->w9,mr_mip->w9,mr_mip->w9);
                nres_modsub(mr_mip->w9,mr_mip->w4,mr_mip->w9);
                subtract(mr_mip->w1,mr_mip->w2,mr_mip->w1);
            }
            else
            { /* v=v*vp-p, vp=vp*vp-2 */
                nres_modmult(mr_mip->w9,mr_mip->w8,mr_mip->w9);
                nres_modsub(mr_mip->w9,mr_mip->w3,mr_mip->w9);
                nres_modmult(mr_mip->w8,mr_mip->w8,mr_mip->w8);
                nres_modsub(mr_mip->w8,mr_mip->w4,mr_mip->w8);
            }
            subdiv(mr_mip->w2,2,mr_mip->w2);
        }
    }

    copy(mr_mip->w9,v);
    if (v!=vp) copy(mr_mip->w8,vp);
    MR_OUT

}

void lucas(big p,big r,big n,big vp,big v)
{
    if (mr_mip->ERNUM) return;

    MR_IN(108)
    prepare_monty(n);
    nres(p,mr_mip->w3);
    nres_lucas(mr_mip->w3,r,mr_mip->w8,mr_mip->w9);
    redc(mr_mip->w9,v);
    if (v!=vp) redc(mr_mip->w8,vp);
    MR_OUT
}

