/*
 *   MIRACL random number routines 
 *   mrrand.c
 *
 *   Copyright (c) 1988-1997 Shamus Software Ltd.
 */

#include <stdio.h>
#include <miracl.h>

extern miracl *mr_mip;

void bigrand(big w,big x)
{  /*  generate a big random number 0<=x<w  */
    int m;
    if (mr_mip->ERNUM) return;

    MR_IN(20)

 /*   decr(w,2,w);  */
    m=0;
    zero(mr_mip->w0);
    do
    { /* create big rand piece by piece */
        m++;
        mr_mip->w0[0]=m;
        if (mr_mip->base==0) mr_mip->w0[m]=brand();
        else                 mr_mip->w0[m]=brand()%mr_mip->base;

    } while (compare(mr_mip->w0,w)<0);
    divide(mr_mip->w0,w,w);
    copy(mr_mip->w0,x);
 /*   incr(x,2,x);
    if (w!=x) incr(w,2,w); */
    MR_OUT
}

void bigdig(int n,int b,big x)
{ /* generate random number n digits long *
   * to "printable" base b                */
    if (mr_mip->ERNUM) return;

    MR_IN(19)

    if (b<2 || b>256)
    {
        mr_berror(MR_ERR_BASE_TOO_BIG);
        MR_OUT
        return;
    }


    do
    { /* repeat if x too small */
        expint(b,n,mr_mip->w1);
        bigrand(mr_mip->w1,x);
        subdiv(mr_mip->w1,b,mr_mip->w1);
    } while (!mr_mip->ERNUM && compare(x,mr_mip->w1)<0);

    MR_OUT
}

